/** Install a property to globalThis. Not intended for direct use. */
export function installGlobal(name, value, opts) {
    if (name in globalThis && !opts?.overwrite) {
        // It already exists.
    }
    else {
        if (!("cicada-lib" in globalThis)) {
            globalThis["cicada-lib"] = {};
        }
        if (!("shims" in globalThis["cicada-lib"])) {
            globalThis["cicada-lib"]["shims"] = new Set();
        }
        if (!globalThis["cicada-lib"]["shims"].has(name)) {
            globalThis[name] = value;
            globalThis["cicada-lib"]["shims"].add(name);
        }
    }
}
//# sourceMappingURL=_util.js.map
